"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// eslint-disable-next-line react/prop-types
var ViewPortList = function ViewPortList(_ref) {
  var _ref$listLength = _ref.listLength,
      listLength = _ref$listLength === void 0 ? 0 : _ref$listLength,
      _ref$itemMinHeight = _ref.itemMinHeight,
      itemMinHeight = _ref$itemMinHeight === void 0 ? 1 : _ref$itemMinHeight,
      _ref$margin = _ref.margin,
      margin = _ref$margin === void 0 ? 0 : _ref$margin,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? null : _ref$children,
      _ref$scrollToIndex = _ref.scrollToIndex,
      scrollToIndex = _ref$scrollToIndex === void 0 ? -1 : _ref$scrollToIndex;
  var itemMinHeightWithMargin = itemMinHeight + margin;
  var maxIndex = listLength - 1;

  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      startIndex = _useState2[0],
      setStartIndex = _useState2[1];

  var _useState3 = (0, _react.useState)(document.documentElement.clientHeight),
      _useState4 = _slicedToArray(_useState3, 2),
      windowHeight = _useState4[0],
      setWindowHeight = _useState4[1];

  var maxVisibleItemsCount = Math.ceil(windowHeight / itemMinHeight) * 2;
  var normalizedStartIndex = Math.min(startIndex, Math.max(maxIndex - maxVisibleItemsCount, 0));
  var endIndex = Math.min(normalizedStartIndex + maxVisibleItemsCount, maxIndex);
  var startRef = (0, _react.useRef)(null);
  var scrollRef = (0, _react.useRef)(null);
  var variables = (0, _react.useRef)({
    scrolledToIndex: -1,
    inc: 1,
    dec: 1,
    stepFunc: function stepFunc() {}
  });

  variables.current.stepFunc = function () {
    if (!startRef.current) {
      variables.current.inc = 1;
      variables.current.dec = 1;
      return;
    }

    var startRefRect = startRef.current.getBoundingClientRect();

    if (startIndex > Math.max(maxIndex - maxVisibleItemsCount)) {
      setStartIndex(Math.max(maxIndex - maxVisibleItemsCount, 0));
      variables.current.inc = 1;
      variables.current.dec = 1;
      return;
    }

    if (scrollToIndex !== variables.current.scrolledToIndex) {
      variables.current.inc = 1;
      variables.current.dec = 1;

      if (scrollToIndex < 0 || scrollToIndex > maxIndex) {
        variables.current.scrolledToIndex = scrollToIndex;
        return;
      }

      if (scrollToIndex >= startIndex && scrollToIndex <= endIndex) {
        (scrollRef.current || startRef.current).scrollIntoView();
        variables.current.scrolledToIndex = scrollToIndex;
        return;
      }

      setStartIndex(Math.min(Math.max(scrollToIndex - Math.floor(maxVisibleItemsCount / 2), 0), Math.max(maxIndex - maxVisibleItemsCount, 0)));
      return;
    }

    if (startRefRect.bottom < -windowHeight) {
      setStartIndex(Math.min(startIndex + variables.current.inc, Math.max(maxIndex - maxVisibleItemsCount, 0)));
      variables.current.inc = variables.current.inc * 2;
      variables.current.dec = 1;
      return;
    }

    if (startRefRect.top > -windowHeight) {
      setStartIndex(Math.max(startIndex - variables.current.dec, 0));
      variables.current.inc = 1;
      variables.current.dec = variables.current.dec * 2;
      return;
    }

    variables.current.inc = 1;
    variables.current.dec = 1;
  };

  (0, _react.useEffect)(function () {
    var onResize = function onResize() {
      setWindowHeight(document.documentElement.clientHeight);
    };

    window.addEventListener('resize', onResize);
    return function () {
      return window.removeEventListener('resize', onResize);
    };
  }, [itemMinHeight]);
  (0, _react.useEffect)(function () {
    var frameId = 0;

    var frame = function frame() {
      frameId = requestAnimationFrame(frame);
      variables.current.stepFunc();
    };

    frame();
    return function () {
      return cancelAnimationFrame(frameId);
    };
  }, []);
  var items = (0, _react.useMemo)(function () {
    if (!children) {
      return false;
    }

    var result = [];

    for (var index = normalizedStartIndex; index <= endIndex; ++index) {
      result.push(children({
        innerRef: index === normalizedStartIndex ? startRef : index === scrollToIndex ? scrollRef : undefined,
        index: index,
        style: {
          marginTop: index === normalizedStartIndex ? normalizedStartIndex * itemMinHeightWithMargin : undefined,
          marginBottom: index === endIndex ? (maxIndex - endIndex) * itemMinHeightWithMargin : margin
        }
      }));
    }

    return result;
  }, [children, endIndex, itemMinHeightWithMargin, margin, maxIndex, normalizedStartIndex, scrollToIndex]);
  return _react.default.createElement(_react.Fragment, null, items);
};

var _default = ViewPortList;
exports.default = _default;